#!/usr/bin/env python
# -*- coding: utf8 -*-

import string, sys, time, csv

tini = time.time()

import cgi, cgitb
cgitb.enable()

print "Content-Type: text/html"     # HTML is following
print                               # blank line, end of headers

sys.path.append("/home/tanique/roundup")
import srvRoundup

header = """
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Votación remeras PyAr v2</title>
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>
<body>

<center>
<h1><b>Votación remeras PyAr v2</b></h1>
<br>
<a href="http://www.python.com.ar/moin/RemerasV2">Ver los diseños</a>
<br>
</center>
<br><br>
"""

firma = """
<center><small>
<br> <br> <br>
<br>- - -
<br>Página generada en %.2f segs
<br>Powered by Python, por supuesto, :)
</small></center>
"""

footer = """
</body>
</html>
"""


form = string.Template("""
<center>
<form method="post" action="votoRemeras.py">
<table class="form" cellspacing="10">
  <tr>
    <td>$corregir_mail</td>
    <td>Mail</td> 
    <td> 
$mailentry
    </td>
  </tr>

  <tr>
    <td>$corregir_voto1</td>
    <td>Voto 1</td> 
    <td> 
      <select name="voto1">
$opciones_voto1
      </select>
    </td>
    <td> 
$valores_voto1
    </td>
  </tr>
  <tr>
    <td>$corregir_voto2</td>
    <td>Voto 2</td> 
    <td> 
      <select name="voto2">
$opciones_voto2
      </select>
    </td>
    <td> 
$valores_voto2
    </td>
  </tr>
  <tr>
    <td>$corregir_voto3</td>
    <td>Voto 3</td> 
    <td> 
      <select name="voto3">
$opciones_voto3
      </select>
    </td>
    <td> 
$valores_voto3
    </td>
  </tr>

  <tr>
    <td colspan="4" align="right">
      <input type="submit" value="Votá!">
    </td>
  </tr>
</table>
</form>
</center>
""")

campos = "mail voto1 voto2 voto3".split()
propuestas = [
    "", 
    "Sin voto",
    "alecu1",
    "CesarPortela1",
    "CesarRoldan1",
    "CesarRoldan2",
    "CesarRoldan3",
    "FacundoBatista1",
    "FacundoBatista2",
    "FacundoBatista3",
    "FacundoBatista4",
    "FacundoBatista5",
    "HernanBalocco1",
    "humitos1",
    "Juanjo1",
    "LauBenech1",
    "LauBenech2",
    "LauBenech3",
    "LauBenech4",
    "LauBenech5",
    "LauBenech6",
    "Nubis1",
    "Nubis2",
    "PabloZiliani1",
    "PabloZiliani2",
    "RamiroMorales1",
]

arch = open("/home/tanique/pyar-suscriptores.txt")
suscriptos = set(x.strip().lower() for x in arch)

def getForm(elegidos):
    dic = {}

    if elegidos.values() == [None]*7:
        # todo vacio
        for c in campos:
            dic["corregir_"+c] = ""
    else:
        # alguno lleno, todos tienen que estarlo!

        # el mail, verificando tambien suscripción
        if elegidos["mail"] is None:
            dic["corregir_mail"] = "Falta este!!"
        elif elegidos["mail"].strip().lower() not in suscriptos:
            dic["corregir_mail"] = "Este mail no está suscripto a la lista!"
        else:
            dic["corregir_mail"] = ""
        
        # los otros campos
        for c in campos[1:]:
#            print c, elegidos[c], elegidos["val"+c]
            if elegidos[c] is None:
                dic["corregir_"+c] = "Falta este!!"
            elif elegidos[c] != "Sin voto" and elegidos["val"+c] is None:
                dic["corregir_"+c] = "Falta este!!"
            else:
                dic["corregir_"+c] = ""

    # el text entry
    if elegidos["mail"] is None:
       val = '<input name="mail" style="width:100%" type="text">'
    else:
       val = '<input name="mail" style="width:100%%" type="text" value="%s">' % elegidos["mail"]
    dic["mailentry"] = val

    # los combo boxes
    for nom in campos[1:]:
        eleg = elegidos[nom]
        vals = []
        
        for prop in propuestas:
            if prop == eleg:
                vals.append('       <option selected="selected" value="%s">%s</option>' % (prop, prop))
            else:
                vals.append('       <option value="%s">%s</option>' % (prop, prop))

        dic["opciones_"+nom] = "\n".join(vals)

    # los radio buttons
    for nom in campos[1:]:
        vals = []
        eleg = elegidos["val"+nom]
        for i in map(str, range(1,6)):
            if i == eleg:
                vals.append('      <input type="radio" name="val%s" value="%s" checked="True"> %s' % (nom, i, i))
            else:
                vals.append('      <input type="radio" name="val%s" value="%s"> %s' % (nom, i, i))
        dic["valores_"+nom] = "\n".join(vals)
            
    return form.substitute(dic)

def votamos(elegidos):
    # info
    log = [time.strftime("%Y-%m-%d %H:%M:%S"), elegidos["mail"]]
    for c in campos[1:]:
        log.append(elegidos[c])
        log.append(elegidos["val"+c])

    # bajamos
    arch = open("/home/tanique/voto_%s.txt" % time.strftime("%Y%m%d"), "a")
    writer = csv.writer(arch)
    writer.writerow(log)
    arch.close()

    # contestamos
    return """<h2><center> ¡Gracias por tu voto! </center></h1>"""
    

fs = cgi.FieldStorage()
elegidos = {}
for kw in "mail voto1 voto2 voto3 valvoto1 valvoto2 valvoto3".split():
    opc = fs.getfirst(kw, None)
    if opc == '0':
        opc = None
    elegidos[kw] = opc

if None in elegidos.values():
    muestra = getForm(elegidos)
elif elegidos["mail"].strip().lower() not in suscriptos:
    muestra = getForm(elegidos)
else:
    muestra = votamos(elegidos)

print header
print muestra
print firma % (time.time()-tini)
print footer
